diff --git a/test/common_plat/common/Makefile.am b/test/common_plat/common/Makefile.am
index 9fd08ee8..5736214a 100644
--- a/test/common_plat/common/Makefile.am
+++ b/test/common_plat/common/Makefile.am
@@ -2,12 +2,10 @@ include $(top_srcdir)/test/Makefile.inc
 
 noinst_LTLIBRARIES = libcunit_common.la libcpumask_common.la libthrmask_common.la
 
-libcunit_common_la_SOURCES = odp_cunit_common.c
+libcunit_common_la_SOURCES = odp_cunit_common.c odp_cunit_common.h
 libcunit_common_la_LIBADD = $(CUNIT_LIBS)
 
-libcpumask_common_la_SOURCES = mask_common.c
+libcpumask_common_la_SOURCES = mask_common.c mask_common.h
 
-libthrmask_common_la_SOURCES = mask_common.c
+libthrmask_common_la_SOURCES = mask_common.c mask_common.h
 libthrmask_common_la_CFLAGS = $(AM_CFLAGS) -DTEST_THRMASK
-
-EXTRA_DIST = mask_common.h odp_cunit_common.h
diff --git a/test/common_plat/miscellaneous/Makefile.am b/test/common_plat/miscellaneous/Makefile.am
index 7d8cf353..48240efe 100644
--- a/test/common_plat/miscellaneous/Makefile.am
+++ b/test/common_plat/miscellaneous/Makefile.am
@@ -9,4 +9,4 @@ odp_api_from_cpp_CXXFLAGS = $(AM_CXXFLAGS)
 
 odp_api_from_cpp_LDFLAGS = $(AM_LDFLAGS) -static
 
-dist_odp_api_from_cpp_SOURCES = odp_api_from_cpp.cpp
+odp_api_from_cpp_SOURCES = odp_api_from_cpp.cpp
diff --git a/test/common_plat/performance/Makefile.am b/test/common_plat/performance/Makefile.am
index 3299f03f..c67de749 100644
--- a/test/common_plat/performance/Makefile.am
+++ b/test/common_plat/performance/Makefile.am
@@ -40,16 +40,15 @@ odp_scheduling_LDFLAGS = $(AM_LDFLAGS) -static
 odp_scheduling_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/test
 
 noinst_HEADERS = \
-		  $(top_srcdir)/test/test_debug.h \
-		  dummy_crc.h
+		  $(top_srcdir)/test/test_debug.h
 
-dist_odp_bench_packet_SOURCES = odp_bench_packet.c
-dist_odp_crypto_SOURCES = odp_crypto.c
-dist_odp_pktio_ordered_SOURCES = odp_pktio_ordered.c
-dist_odp_sched_latency_SOURCES = odp_sched_latency.c
-dist_odp_scheduling_SOURCES = odp_scheduling.c
-dist_odp_pktio_perf_SOURCES = odp_pktio_perf.c
+odp_bench_packet_SOURCES = odp_bench_packet.c
+odp_crypto_SOURCES = odp_crypto.c
+odp_pktio_ordered_SOURCES = odp_pktio_ordered.c dummy_crc.h
+odp_sched_latency_SOURCES = odp_sched_latency.c
+odp_scheduling_SOURCES = odp_scheduling.c
+odp_pktio_perf_SOURCES = odp_pktio_perf.c
 
-EXTRA_DIST = $(TESTSCRIPTS)
+dist_check_SCRIPTS = $(TESTSCRIPTS)
 
-dist_check_SCRIPTS = udp64.pcap
+dist_check_DATA = udp64.pcap
diff --git a/test/common_plat/validation/api/atomic/Makefile.am b/test/common_plat/validation/api/atomic/Makefile.am
index 9b6bd631..b09d3b88 100644
--- a/test/common_plat/validation/api/atomic/Makefile.am
+++ b/test/common_plat/validation/api/atomic/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestatomic.la
-libtestatomic_la_SOURCES = atomic.c
-
 test_PROGRAMS = atomic_main$(EXEEXT)
-dist_atomic_main_SOURCES = atomic_main.c
-atomic_main_LDADD = libtestatomic.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = atomic.h
+atomic_main_SOURCES = atomic_main.c atomic.c atomic.h
+atomic_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/barrier/Makefile.am b/test/common_plat/validation/api/barrier/Makefile.am
index 8fc632c2..4dfb1d1e 100644
--- a/test/common_plat/validation/api/barrier/Makefile.am
+++ b/test/common_plat/validation/api/barrier/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestbarrier.la
-libtestbarrier_la_SOURCES = barrier.c
-
 test_PROGRAMS = barrier_main$(EXEEXT)
-dist_barrier_main_SOURCES = barrier_main.c
-barrier_main_LDADD = libtestbarrier.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = barrier.h
+barrier_main_SOURCES = barrier_main.c barrier.c barrier.h
+barrier_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/buffer/Makefile.am b/test/common_plat/validation/api/buffer/Makefile.am
index add2a341..ae6ce0a4 100644
--- a/test/common_plat/validation/api/buffer/Makefile.am
+++ b/test/common_plat/validation/api/buffer/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestbuffer.la
-libtestbuffer_la_SOURCES = buffer.c
-
 test_PROGRAMS = buffer_main$(EXEEXT)
-dist_buffer_main_SOURCES = buffer_main.c
-buffer_main_LDADD = libtestbuffer.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = buffer.h
+buffer_main_SOURCES = buffer_main.c buffer.c buffer.h
+buffer_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/classification/Makefile.am b/test/common_plat/validation/api/classification/Makefile.am
index df382c51..f177528e 100644
--- a/test/common_plat/validation/api/classification/Makefile.am
+++ b/test/common_plat/validation/api/classification/Makefile.am
@@ -1,14 +1,12 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestclassification.la
-libtestclassification_la_SOURCES = odp_classification_basic.c \
-			       odp_classification_tests.c \
-			       odp_classification_test_pmr.c \
-			       odp_classification_common.c \
-			       classification.c
-
 test_PROGRAMS = classification_main$(EXEEXT)
-dist_classification_main_SOURCES = classification_main.c
-classification_main_LDADD = libtestclassification.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = classification.h odp_classification_testsuites.h
+classification_main_SOURCES = classification_main.c \
+				   odp_classification_basic.c \
+				   odp_classification_tests.c \
+				   odp_classification_testsuites.h \
+				   odp_classification_test_pmr.c \
+				   odp_classification_common.c \
+				   classification.c \
+				   classification.h
+classification_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/cpumask/Makefile.am b/test/common_plat/validation/api/cpumask/Makefile.am
index ec5fce33..ddafb9ab 100644
--- a/test/common_plat/validation/api/cpumask/Makefile.am
+++ b/test/common_plat/validation/api/cpumask/Makefile.am
@@ -1,11 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestcpumask.la
-libtestcpumask_la_SOURCES = cpumask.c
-libtestcpumask_la_LIBADD = $(LIBCPUMASK_COMMON)
-
 test_PROGRAMS = cpumask_main$(EXEEXT)
-dist_cpumask_main_SOURCES = cpumask_main.c
-cpumask_main_LDADD = libtestcpumask.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = cpumask.h
+cpumask_main_SOURCES = cpumask_main.c cpumask.c cpumask.h
+cpumask_main_LDADD = $(LIBCPUMASK_COMMON) $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/crypto/Makefile.am b/test/common_plat/validation/api/crypto/Makefile.am
index 3ea41b41..6660e1b2 100644
--- a/test/common_plat/validation/api/crypto/Makefile.am
+++ b/test/common_plat/validation/api/crypto/Makefile.am
@@ -1,11 +1,11 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestcrypto.la
-libtestcrypto_la_SOURCES = crypto.c \
-		       odp_crypto_test_inp.c
-
 test_PROGRAMS = crypto_main$(EXEEXT)
-dist_crypto_main_SOURCES = crypto_main.c
-crypto_main_LDADD = libtestcrypto.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = crypto.h odp_crypto_test_inp.h test_vectors.h test_vectors_len.h
+crypto_main_SOURCES = crypto_main.c \
+		      crypto.c \
+		      crypto.h \
+		      odp_crypto_test_inp.c \
+		      odp_crypto_test_inp.h \
+		      test_vectors.h \
+		      test_vectors_len.h
+crypto_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/errno/Makefile.am b/test/common_plat/validation/api/errno/Makefile.am
index a24275d6..8f7b2e88 100644
--- a/test/common_plat/validation/api/errno/Makefile.am
+++ b/test/common_plat/validation/api/errno/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtesterrno.la
-libtesterrno_la_SOURCES = errno.c
-
 test_PROGRAMS = errno_main$(EXEEXT)
-dist_errno_main_SOURCES = errno_main.c
-errno_main_LDADD = libtesterrno.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = errno.h
+errno_main_SOURCES = errno_main.c errno.c errno.h
+errno_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/hash/Makefile.am b/test/common_plat/validation/api/hash/Makefile.am
index b899b8bd..b37f2e00 100644
--- a/test/common_plat/validation/api/hash/Makefile.am
+++ b/test/common_plat/validation/api/hash/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtesthash.la
-libtesthash_la_SOURCES = hash.c
-
 test_PROGRAMS = hash_main$(EXEEXT)
-dist_hash_main_SOURCES = hash_main.c
-hash_main_LDADD = libtesthash.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = hash.h
+hash_main_SOURCES = hash_main.c hash.c hash.h
+hash_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/init/Makefile.am b/test/common_plat/validation/api/init/Makefile.am
index 0793e642..ba25c61f 100644
--- a/test/common_plat/validation/api/init/Makefile.am
+++ b/test/common_plat/validation/api/init/Makefile.am
@@ -1,16 +1,12 @@
 include ../Makefile.inc
-noinst_LTLIBRARIES = libtestinit.la
-libtestinit_la_SOURCES = init.c
 
 # most platforms are expected not to support multiple ODP inits
 # following each other: therefore 3 separate binaries are
 # created, each containing its ODP init test.
 test_PROGRAMS = init_main_abort$(EXEEXT) init_main_log$(EXEEXT) init_main_ok$(EXEEXT)
-dist_init_main_abort_SOURCES = init_main_abort.c
-dist_init_main_log_SOURCES   = init_main_log.c
-dist_init_main_ok_SOURCES    = init_main_ok.c
-init_main_abort_LDADD = libtestinit.la $(LIBCUNIT_COMMON) $(LIBODP)
-init_main_log_LDADD   = libtestinit.la $(LIBCUNIT_COMMON) $(LIBODP)
-init_main_ok_LDADD    = libtestinit.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = init.h
+init_main_abort_SOURCES = init_main_abort.c init.c init.h
+init_main_log_SOURCES   = init_main_log.c init.c init.h
+init_main_ok_SOURCES    = init_main_ok.c init.c init.h
+init_main_abort_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
+init_main_log_LDADD   = $(LIBCUNIT_COMMON) $(LIBODP)
+init_main_ok_LDADD    = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/lock/Makefile.am b/test/common_plat/validation/api/lock/Makefile.am
index 29993df4..80740282 100644
--- a/test/common_plat/validation/api/lock/Makefile.am
+++ b/test/common_plat/validation/api/lock/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestlock.la
-libtestlock_la_SOURCES = lock.c
-
 test_PROGRAMS = lock_main$(EXEEXT)
-dist_lock_main_SOURCES = lock_main.c
-lock_main_LDADD = libtestlock.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = lock.h
+lock_main_SOURCES = lock_main.c lock.c lock.h
+lock_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/packet/Makefile.am b/test/common_plat/validation/api/packet/Makefile.am
index d8ebc1a2..fb356997 100644
--- a/test/common_plat/validation/api/packet/Makefile.am
+++ b/test/common_plat/validation/api/packet/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestpacket.la
-libtestpacket_la_SOURCES = packet.c
-
 test_PROGRAMS = packet_main$(EXEEXT)
-dist_packet_main_SOURCES = packet_main.c
-packet_main_LDADD = libtestpacket.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = packet.h
+packet_main_SOURCES = packet_main.c packet.c packet.h
+packet_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/pktio/Makefile.am b/test/common_plat/validation/api/pktio/Makefile.am
index c6368fba..eb4b6038 100644
--- a/test/common_plat/validation/api/pktio/Makefile.am
+++ b/test/common_plat/validation/api/pktio/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestpktio.la
-libtestpktio_la_SOURCES = pktio.c
-
 test_PROGRAMS = pktio_main$(EXEEXT)
-dist_pktio_main_SOURCES = pktio_main.c parser.c
-pktio_main_LDADD = libtestpktio.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = pktio.h parser.h
+pktio_main_SOURCES = pktio_main.c parser.c parser.h pktio.c pktio.h
+pktio_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/pool/Makefile.am b/test/common_plat/validation/api/pool/Makefile.am
index 1eb8d714..85a37b05 100644
--- a/test/common_plat/validation/api/pool/Makefile.am
+++ b/test/common_plat/validation/api/pool/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestpool.la
-libtestpool_la_SOURCES = pool.c
-
 test_PROGRAMS = pool_main$(EXEEXT)
-dist_pool_main_SOURCES = pool_main.c
-pool_main_LDADD = libtestpool.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = pool.h
+pool_main_SOURCES = pool_main.c pool.c pool.h
+pool_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/queue/Makefile.am b/test/common_plat/validation/api/queue/Makefile.am
index a477e3c5..a5b6a9b1 100644
--- a/test/common_plat/validation/api/queue/Makefile.am
+++ b/test/common_plat/validation/api/queue/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestqueue.la
-libtestqueue_la_SOURCES = queue.c
-
 test_PROGRAMS = queue_main$(EXEEXT)
-dist_queue_main_SOURCES = queue_main.c
-queue_main_LDADD = libtestqueue.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = queue.h
+queue_main_SOURCES = queue_main.c queue.c queue.h
+queue_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/random/Makefile.am b/test/common_plat/validation/api/random/Makefile.am
index 69259a4d..e026f045 100644
--- a/test/common_plat/validation/api/random/Makefile.am
+++ b/test/common_plat/validation/api/random/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestrandom.la
-libtestrandom_la_SOURCES = random.c
-
 test_PROGRAMS = random_main$(EXEEXT)
-dist_random_main_SOURCES = random_main.c
-random_main_LDADD = libtestrandom.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = random.h
+random_main_SOURCES = random_main.c random.c random.h
+random_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/scheduler/Makefile.am b/test/common_plat/validation/api/scheduler/Makefile.am
index 2555cab8..6c71b010 100644
--- a/test/common_plat/validation/api/scheduler/Makefile.am
+++ b/test/common_plat/validation/api/scheduler/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestscheduler.la
-libtestscheduler_la_SOURCES = scheduler.c
-
 test_PROGRAMS = scheduler_main$(EXEEXT)
-dist_scheduler_main_SOURCES = scheduler_main.c
-scheduler_main_LDADD = libtestscheduler.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = scheduler.h
+scheduler_main_SOURCES = scheduler_main.c scheduler.c scheduler.h
+scheduler_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/shmem/Makefile.am b/test/common_plat/validation/api/shmem/Makefile.am
index da88af66..d955cc22 100644
--- a/test/common_plat/validation/api/shmem/Makefile.am
+++ b/test/common_plat/validation/api/shmem/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestshmem.la
-libtestshmem_la_SOURCES = shmem.c
-
 test_PROGRAMS = shmem_main$(EXEEXT)
-dist_shmem_main_SOURCES = shmem_main.c
-shmem_main_LDADD = libtestshmem.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = shmem.h
+shmem_main_SOURCES = shmem_main.c shmem.c shmem.h
+shmem_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/std_clib/Makefile.am b/test/common_plat/validation/api/std_clib/Makefile.am
index e2fc0ccf..919c2556 100644
--- a/test/common_plat/validation/api/std_clib/Makefile.am
+++ b/test/common_plat/validation/api/std_clib/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libteststd_clib.la
-libteststd_clib_la_SOURCES = std_clib.c
-
 test_PROGRAMS = std_clib_main$(EXEEXT)
-dist_std_clib_main_SOURCES = std_clib_main.c
-std_clib_main_LDADD = libteststd_clib.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = std_clib.h
+std_clib_main_SOURCES = std_clib_main.c std_clib.c std_clib.h
+std_clib_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/system/Makefile.am b/test/common_plat/validation/api/system/Makefile.am
index 3789c36c..15e6d49a 100644
--- a/test/common_plat/validation/api/system/Makefile.am
+++ b/test/common_plat/validation/api/system/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestsystem.la
-libtestsystem_la_SOURCES = system.c
-
 test_PROGRAMS = system_main$(EXEEXT)
-dist_system_main_SOURCES = system_main.c
-system_main_LDADD = libtestsystem.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = system.h
+system_main_SOURCES = system_main.c system.c system.h
+system_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/thread/Makefile.am b/test/common_plat/validation/api/thread/Makefile.am
index eaf680cf..59e136b2 100644
--- a/test/common_plat/validation/api/thread/Makefile.am
+++ b/test/common_plat/validation/api/thread/Makefile.am
@@ -1,12 +1,6 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestthread.la
-libtestthread_la_SOURCES = thread.c
-libtestthread_la_CFLAGS = $(AM_CFLAGS) -DTEST_THRMASK
-libtestthread_la_LIBADD = $(LIBTHRMASK_COMMON)
-
 test_PROGRAMS = thread_main$(EXEEXT)
-dist_thread_main_SOURCES = thread_main.c
-thread_main_LDADD = libtestthread.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = thread.h
+thread_main_CPPFLAGS = $(AM_CPPFLAGS) -DTEST_THRMASK
+thread_main_SOURCES = thread_main.c thread.c thread.h
+thread_main_LDADD = $(LIBTHRMASK_COMMON) $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/time/Makefile.am b/test/common_plat/validation/api/time/Makefile.am
index ca9c0562..faed577f 100644
--- a/test/common_plat/validation/api/time/Makefile.am
+++ b/test/common_plat/validation/api/time/Makefile.am
@@ -7,13 +7,9 @@ TEST_EXTENSIONS = .sh
 
 TESTS = $(TESTSCRIPTS)
 
-noinst_LTLIBRARIES = libtesttime.la
-libtesttime_la_SOURCES = time.c
-
 test_PROGRAMS = time_main$(EXEEXT)
-dist_time_main_SOURCES = time_main.c
-time_main_LDADD = libtesttime.la $(LIBCUNIT_COMMON) $(LIBODP)
+time_main_SOURCES = time_main.c time.c time_test.h
+time_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
 
-EXTRA_DIST = time_test.h $(TESTSCRIPTS)
 dist_check_SCRIPTS = $(TESTSCRIPTS)
 test_SCRIPTS = $(dist_check_SCRIPTS)
diff --git a/test/common_plat/validation/api/timer/Makefile.am b/test/common_plat/validation/api/timer/Makefile.am
index fe6872f4..4f79020d 100644
--- a/test/common_plat/validation/api/timer/Makefile.am
+++ b/test/common_plat/validation/api/timer/Makefile.am
@@ -1,10 +1,5 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtesttimer.la
-libtesttimer_la_SOURCES = timer.c
-
 test_PROGRAMS = timer_main$(EXEEXT)
-dist_timer_main_SOURCES = timer_main.c
-timer_main_LDADD = libtesttimer.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-EXTRA_DIST = timer.h
+timer_main_SOURCES = timer_main.c timer.c timer.h
+timer_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/common_plat/validation/api/traffic_mngr/Makefile.am b/test/common_plat/validation/api/traffic_mngr/Makefile.am
index 44d50a91..3884a13c 100644
--- a/test/common_plat/validation/api/traffic_mngr/Makefile.am
+++ b/test/common_plat/validation/api/traffic_mngr/Makefile.am
@@ -7,13 +7,9 @@ TEST_EXTENSIONS = .sh
 
 TESTS = $(TESTSCRIPTS)
 
-noinst_LTLIBRARIES = libtesttraffic_mngr.la
-libtesttraffic_mngr_la_SOURCES = traffic_mngr.c
-
 test_PROGRAMS = traffic_mngr_main$(EXEEXT)
-dist_traffic_mngr_main_SOURCES = traffic_mngr_main.c
-traffic_mngr_main_LDADD = libtesttraffic_mngr.la -lm $(LIBCUNIT_COMMON) $(LIBODP)
+traffic_mngr_main_SOURCES = traffic_mngr_main.c traffic_mngr.c traffic_mngr.h
+traffic_mngr_main_LDADD = -lm $(LIBCUNIT_COMMON) $(LIBODP)
 
-EXTRA_DIST = traffic_mngr.h $(TESTSCRIPTS)
 dist_check_SCRIPTS = $(TESTSCRIPTS)
 test_SCRIPTS = $(dist_check_SCRIPTS)
diff --git a/test/linux-generic/mmap_vlan_ins/Makefile.am b/test/linux-generic/mmap_vlan_ins/Makefile.am
index 5cac159c..5fb6afd9 100644
--- a/test/linux-generic/mmap_vlan_ins/Makefile.am
+++ b/test/linux-generic/mmap_vlan_ins/Makefile.am
@@ -12,4 +12,4 @@ plat_mmap_vlan_ins_LDFLAGS = $(AM_LDFLAGS) -static
 plat_mmap_vlan_ins_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
 # Clonned from example odp_l2fwd simple
-dist_plat_mmap_vlan_ins_SOURCES = mmap_vlan_ins.c
+plat_mmap_vlan_ins_SOURCES = mmap_vlan_ins.c
diff --git a/test/linux-generic/pktio_ipc/Makefile.am b/test/linux-generic/pktio_ipc/Makefile.am
index 8858bd2f..ad5de50b 100644
--- a/test/linux-generic/pktio_ipc/Makefile.am
+++ b/test/linux-generic/pktio_ipc/Makefile.am
@@ -9,12 +9,8 @@ pktio_ipc1_LDFLAGS = $(AM_LDFLAGS) -static
 pktio_ipc2_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 pktio_ipc2_LDFLAGS = $(AM_LDFLAGS) -static
 
-noinst_HEADERS = $(top_srcdir)/test/test_debug.h
-
-dist_pktio_ipc1_SOURCES = pktio_ipc1.c ipc_common.c
-dist_pktio_ipc2_SOURCES = pktio_ipc2.c ipc_common.c
-
-EXTRA_DIST = ipc_common.h
+pktio_ipc1_SOURCES = pktio_ipc1.c ipc_common.c ipc_common.h
+pktio_ipc2_SOURCES = pktio_ipc2.c ipc_common.c ipc_common.h
 
 dist_check_SCRIPTS = pktio_ipc_run.sh
 test_SCRIPTS = $(dist_check_SCRIPTS)
diff --git a/test/linux-generic/ring/Makefile.am b/test/linux-generic/ring/Makefile.am
index 14f60b85..57ba82ae 100644
--- a/test/linux-generic/ring/Makefile.am
+++ b/test/linux-generic/ring/Makefile.am
@@ -1,15 +1,11 @@
 include ../Makefile.inc
 
-noinst_LTLIBRARIES = libtestring.la
-libtestring_la_SOURCES = ring_suites.c ring_basic.c ring_stress.c
-libtestring_la_CFLAGS = $(AM_CFLAGS) $(INCCUNIT_COMMON) $(INCODP)
-
 test_PROGRAMS = ring_main$(EXEEXT)
-dist_ring_main_SOURCES = ring_main.c
-
-ring_main_CFLAGS = $(AM_CFLAGS) -I$(top_builddir)/include
-ring_main_LDFLAGS = $(AM_LDFLAGS)
-ring_main_LDADD = libtestring.la $(LIBCUNIT_COMMON) $(LIBODP)
-
-noinst_HEADERS = ring_suites.h
-
+ring_main_SOURCES = \
+		    ring_main.c \
+		    ring_suites.c ring_suites.h \
+		    ring_basic.c ring_stress.c
+
+ring_main_CPPFLAGS = $(AM_CPPFLAGS) -I$(top_builddir)/include \
+		     $(INCCUNIT_COMMON) $(INCODP)
+ring_main_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
diff --git a/test/linux-generic/validation/api/shmem/Makefile.am b/test/linux-generic/validation/api/shmem/Makefile.am
index e330d633..6ff77b00 100644
--- a/test/linux-generic/validation/api/shmem/Makefile.am
+++ b/test/linux-generic/validation/api/shmem/Makefile.am
@@ -1,29 +1,24 @@
 include ../Makefile.inc
 
 #the main test program is shmem_linux, which, in turn, starts a shmem_odp:
-test_PROGRAMS = shmem_linux$(EXEEXT)
-test_extra_PROGRAMS = shmem_odp1$(EXEEXT) shmem_odp2$(EXEEXT)
-test_extradir = $(testdir)
+test_PROGRAMS = shmem_linux$(EXEEXT) shmem_odp1$(EXEEXT) shmem_odp2$(EXEEXT)
 
 #shmem_linux is stand alone, pure linux (no ODP):
-dist_shmem_linux_SOURCES = shmem_linux.c
+shmem_linux_SOURCES = shmem_linux.c shmem_linux.h shmem_common.h
 shmem_linux_CFLAGS = $(AM_CFLAGS) -I$(top_builddir)/include
 shmem_linux_LDFLAGS = $(AM_LDFLAGS) -lrt
 
 #shmem_odp1 and shmem_odp2 are the 2 ODP processes:
-dist_shmem_odp1_SOURCES = shmem_odp1.c
+shmem_odp1_SOURCES = shmem_odp1.c shmem_odp1.h shmem_common.h
 shmem_odp1_CFLAGS = $(AM_CFLAGS) \
 		   $(INCCUNIT_COMMON) \
 		   $(INCODP)
 shmem_odp1_LDFLAGS = $(AM_LDFLAGS)
 shmem_odp1_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
 
-dist_shmem_odp2_SOURCES = shmem_odp2.c
+shmem_odp2_SOURCES = shmem_odp2.c shmem_odp2.h shmem_common.h
 shmem_odp2_CFLAGS = $(AM_CFLAGS) \
 		   $(INCCUNIT_COMMON) \
 		   $(INCODP)
 shmem_odp2_LDFLAGS = $(AM_LDFLAGS)
 shmem_odp2_LDADD = $(LIBCUNIT_COMMON) $(LIBODP)
-
-
-noinst_HEADERS = shmem_common.h shmem_linux.h shmem_odp1.h shmem_odp2.h
diff --git a/test/linux-generic/validation/api/shmem/shmem.h b/test/linux-generic/validation/api/shmem/shmem.h
deleted file mode 100644
index 2368a2e1..00000000
--- a/test/linux-generic/validation/api/shmem/shmem.h
+++ /dev/null
@@ -1,21 +0,0 @@
-/* Copyright (c) 2016, Linaro Limited
- * All rights reserved.
- *
- * SPDX-License-Identifier:     BSD-3-Clause
- */
-
-#ifndef _ODP_LINUX_TEST_SHMEM_H_
-#define _ODP_LINUX_TEST_SHMEM_H_
-
-#include <odp_cunit_common.h>
-
-/* test functions: */
-void shmem_test_odp_shm_proc(void);
-
-/* test arrays: */
-extern odp_testinfo_t shmem_linux_suite[];
-
-/* test registry: */
-extern odp_suiteinfo_t shmem_linux_suites[];
-
-#endif